<!--智能报警器-->
<template>
  <div class="app-container smartAlarm">
    <el-form :model="queryParamsData" class="form-box" ref="queryForm" :inline="true">
      <el-form-item label="关键字" prop="searchValue">
        <el-input
          maxLength="30"
          v-model="queryParamsData.searchValue"
          placeholder="设备编号/实验室"
          clearable
          size="small"
          style="width: 240px"/>
      </el-form-item>
      <el-form-item label="学院" prop="deptId">
        <el-select v-model="queryParamsData.deptId" clearable placeholder="请选择学院">
          <el-option
            v-for="item in optionsListOne"
            :key="item.deptId"
            :label="item.deptName"
            :value="item.deptId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="deviceStatus">
        <el-select v-model="queryParamsData.deviceStatus" clearable placeholder="请选择状态">
          <el-option
            v-for="item in optionsListTwo"
            :key="item.id"
            :label="item.name"
            :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <p class="inquire-button-one" @click="handleQuery" style="margin-right:10px;">查询</p>
        <p class="reset-button-one" @click="resetQuery">重置</p>
      </el-form-item>
      <el-form-item style="float: right;">
        <el-col :span="1.5" v-hasPermi="['laboratory:hardware8:add']">
          <p class="add-button-one-90"
             @click="pageToggle(1)"
          ><i class="el-icon-plus"></i>新增</p>
        </el-col>
      </el-form-item>
      <el-form-item style="float: right;">
        <el-col :span="1.5" v-hasPermi="['chemical:hxpSmartTerminalConfig:edit']">
          <p class="add-button-one-90"
             @click="pageToggle(4)"
          >报警设置</p>
        </el-col>
      </el-form-item>
      <el-form-item style="float: right;">
        <el-dropdown @command="importButton" v-hasPermi="['laboratory:hardware8:import']">
          <div class="form-dropdown-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_jzgxx_dr.png">
            <p>导入</p>
            <img src="@/assets/ZDimages/personnelManagement/icon_jzggl_xljt.png">
          </div>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item style="border-bottom:1px solid #E0E0E0;margin:0 10px;color:#333;" :command="{command:1}">下载模板</el-dropdown-item>
            <el-dropdown-item style="margin:0 10px;color:#666;" :command="{command:2}">导入数据</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </el-form-item>
    </el-form>
    <el-table  border :data="tableList" @selection-change="handleSelectionChange" ref="multipleTable" :row-key="getRowKeys">
      <el-table-column type="selection" width="50" align="center" :reserve-selection="true"/>
      <el-table-column label="智能报警器编号" align="center" prop="hardwareNum"/>
      <el-table-column label="学院" align="center" prop="deptName" width="180"/>
      <el-table-column label="位置" align="center" prop="posi" width="250" show-overflow-tooltip/>
      <el-table-column label="设备状态" align="center" prop="status" width="80">
        <template slot-scope="scope">{{scope.row.status == 3||scope.row.status == 4?'在线':'离线'}}</template>
      </el-table-column>
      <el-table-column label="报警时长" align="center" prop="ringTime" width="80">
        <template slot-scope="scope">{{scope.row.ringTime?scope.row.ringTime+'秒':'未设置'}}</template>
      </el-table-column>
      <el-table-column label="处理时长" align="center" prop="dealTime" width="80">
        <template slot-scope="scope">{{scope.row.dealTime?scope.row.dealTime+'分钟':'未设置'}}</template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180"/>
      <el-table-column label="创建人" align="center" prop="createBy" width="150"/>
      <el-table-column label="操作" align="center" width="220" class-name="small-padding fixed-width" v-if="tableButtonType">
        <template slot-scope="scope">
          <div class="button-box">
            <p style="margin-left:20px;">
              <el-switch
                @click.native="changeIsNeedCaptcha(scope.row)"
                class="switch captcha-img"
                :active-value="1"
                :inactive-value="0"
                active-color="#0183FA"
                inactive-color="#999"
                v-model="scope.row.deviceStatus"
                active-text="启用"
                inactive-text="停用"
                disabled
              ></el-switch>
            </p>
            <p class="table-min-button" style="margin-right:10px;" v-hasPermi="['laboratory:hardware8:edit']" @click="pageToggle(2,scope.row)">编辑</p>
            <p class="table-min-button" v-hasPermi="['laboratory:hardware8:remove']" @click="pageToggle(3,scope.row)">删除</p>
          </div>
        </template>
      </el-table-column>
    </el-table>
    <div style="display: flex;height:32px;margin:15px 0;">
      <!--<p style="flex:4;"></p>-->
      <p style="text-align: left;margin:0;line-height:32px;margin-right:20px;font-size:14px;color:#999;">
        <i class="el-icon-warning" style="color:#0183FA;"></i>
        已选择 {{selectedNum}} 项
      </p>
      <div style="flex:5;">
        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </div>
    </div>
    <!--导入窗口-->
    <el-dialog title="导入数据" :visible.sync="importOpen" @close="importOpenOff" width="600px" append-to-body class="import-dialog-box">
      <div class="el-upload__text" style="margin:0 0 20px 58px;">提示：导入后的数据将覆盖原有数据</div>
      <el-upload
        class="import-dialog-upLoad-box"
        :drag="true"
        :data="upImportData"
        :action="uploadImgUrl"
        :show-file-list="false"
        :on-success="handleAvatarSuccess"
        :headers="headers"
        :before-upload="beforeAvatarUpload">
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <!--<div class="el-upload__tip" slot="tip">-->
        <!--<el-checkbox v-model="upImportData.upDate">是否更新已经存在的数据</el-checkbox>-->
        <!--</div>-->
        <div class="el-upload__tip" slot="tip">数据导入模板.xlsx<span style="color:#0183FA;cursor: pointer" @click="importTemplate">下载</span></div>
        <div class="el-upload-text-box" slot="tip" v-if="getImportData.downFile">
          <div class="img-text-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_dr_wj.png">
            <p>{{getImportData.textName}}</p>
          </div>
          <p class="text-p">数据导入成功 <span style="color:#0183FA;">{{getImportData.successNum}}</span> 条，失败 <span style="color:#FF6464 ;">{{getImportData.failureNum}}</span> 条</p>
          <div class="img-text-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_dr_sj.png">
            <p style="color:#0183FA;cursor: pointer;" @click="failureExcel">点击下载失败数据报表</p>
          </div>
        </div>
      </el-upload>
      <div slot="footer" class="teacher-import-dialog-button-box">
        <p class="inquire-button-one" @click="importOpenOff">确定</p>
      </div>
      <div class="teacher-import-dialog-position-box" v-if="loading"></div>
    </el-dialog>
    <!--新增/编辑-->
    <el-dialog :title="dialogTitle" :visible.sync="addDialogType" v-if="addDialogType" width="550px" append-to-body class="add-dialog-box">
      <el-form ref="form" :model="form" :rules="rules" label-width="140px">
        <el-form-item label="智能报警器编号：" prop="hardwareNum">
          <el-input v-model="form.hardwareNum" placeholder="最大20个字符，包含大小写字母、数字" onkeyup="value=value.replace(/[^\w\.\/]/ig,'')" maxlength="30" style="width:360px;"/>
        </el-form-item>
        <el-form-item label="实验室：" prop="subjectId">
          <el-select
            style="width:360px;"
            v-model="form.subjectId"
            filterable
            remote
            clearable
            reserve-keyword
            @focus="selectFocus"
            @clear="clearClick"
            placeholder="搜索选择实验室"
            :remote-method="getSelectList"
            :loading="loading">
            <el-option
              v-for="item in selectList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="继电器类型">
          <el-radio-group v-model="form.hardwareType" style="width:360px;">
            <el-radio :label="item.value" :key="item.value" v-for="(item,index) in hardwardTypeList">{{item.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="绑定继电器" prop="relayCode" v-if="form.hardwareType==1">
          <el-select v-model="form.relayCode" placeholder="请选择继电器" clearable style="width:360px;">
            <el-option v-for="relay in relayList"
                       :key="relay.code"
                       :label="relay.code"
                       :value="relay.code">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="继电器编号"  prop="relayCode" v-if="form.hardwareType==2">
          <el-input
            style="width:360px;"
            v-model="form.relayCode"
            placeholder="请输入继电器编号"
            clearable
            size="small"
            maxlength="20"
          />
        </el-form-item>
        <el-form-item label="继电器位置" prop="bit" >
          <el-select v-model="form.bit" placeholder="请选择继电器位置" clearable style="width:360px;">
            <el-option v-for="lab in relayNumList"
                       :key="lab.name"
                       :label="lab.name"
                       :value="lab.name">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="配置名称"  prop="relayCode" v-if="form.hardwareType==2">
          <el-input
            style="width:360px;"
            v-model="form.configName"
            placeholder="请输入配置名称"
            clearable
            size="small"
            maxLength="15"
          />
        </el-form-item>
        <el-form-item label="配置状态"  prop="relayCode" v-if="form.hardwareType==2">
          <el-input
            style="width:360px;"
            v-model="form.configStatus"
            placeholder="请输入配置状态"
            clearable
            size="small"
            maxLength="8"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--报警设置-->
    <el-dialog title="报警设置" :visible.sync="setUpType" v-if="setUpType" width="550px" append-to-body class="add-dialog-box">
      <el-form ref="setUpForm" :model="setUpForm" :rules="rules" label-width="120px">
        <el-form-item label="报警时长：" prop="ringTime">
          <el-input v-model="setUpForm.ringTime" placeholder="请输入报警时长" maxlength="3" style="width:360px;"
                    onkeyup="this.value=this.value.replace(/\D/g,'')" onafterpaste="this.value=this.value.replace(/\D/g,'')">
            <template slot="append">秒</template>
          </el-input>
        </el-form-item>
        <el-form-item label="处理时长：" prop="dealTime">
          <el-input v-model="setUpForm.dealTime" placeholder="请输入处理时长" maxlength="3" style="width:360px;"
                    onkeyup="this.value=this.value.replace(/\D/g,'')" onafterpaste="this.value=this.value.replace(/\D/g,'')">
            <template slot="append">分钟</template>
          </el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="setUpSubmitForm">确 定</el-button>
        <el-button @click="setUpCancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import mqtt from 'mqtt'
  import { hxpSmartTerminal,filterDept,getSubList,addHxpSmartTerminal,putHxpSmartTerminal,getHxpSmartTerminal,delHxpSmartTerminal,updateStatus,alarmSettings } from "@/api/medicUniversity-3_1/index";
  import { listHardware, delHardware, addHardware, updateHardware, hardWareControl } from "@/api/medicUniversity-3_1/index";
  import { listRelay } from "@/api/laboratory/relay";
  import { listDepartments } from "@/api/system/dept";
  import { getToken } from "@/utils/auth";
  export default {
    name: "smartAlarm",
    data() {
      return {
        //MQTT请求参数-设备
        mtopic:"lab/hardware/data",
        // table操作按钮校验
        tableButtonType:this.hasPermiDom(['laboratory:hardware8:edit','laboratory:hardware8:remove']),
        //上传相关配置
        uploadImgUrl: window.location.href.split('://')[0]+'://' + process.env.VUE_APP_BASE_API + "/laboratory/hardware/importData", // 上传地址
        headers: {
          Authorization: "Bearer " + getToken(),
        },
        // 遮罩层
        loading:false,
        //页面状态
        pageType:1,
        // 搜索数据
        queryParamsData:{
          pageNum:1,
          pageSize:10,
        },
        // 搜索实际发送数据
        queryParams:{
          pageNum:1,
          pageSize:10,
        },
        //数据数量
        total:0,
        //数据数组
        tableList:[],
        //表格扩展选择器---需要在@selection-change绑定的方法内监控selection数组长度
        selectedNum:0,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        //学院列表
        optionsListOne:[],
        //状态列表
        optionsListTwo:[{id:"1",name:"启用"},{id:"0",name:"停用"}],
        //导入弹层开关
        importOpen:false,
        //导入数据
        upImportData:{
          sysUserEnable:true,
          upDate:false,
          terminalType:'AI_ALARM',
        },
        getImportData:{
          downFile:false,
          successNum:0,
          failureNum:0,
          textName:"",
        },
        //编辑新增相关
        dialogTitle:"",
        addDialogType:false,
        form:{},
        selectList:[],
        selectListData:[],
        relayNum: "",
        rules:{
          hardwareNum: [
            { required: true, trigger: "blur", message: "最大20个字符，包含大小写字母、数字" },
            { required: true, message: "最大20个字符，包含大小写字母、数字", validator: this.spaceJudgment, trigger: "blur" }
          ],
          subjectId: [
            { required: true, trigger: "blur", message: "搜索选择实验室" },
          ],
          ringTime: [
            { required: true, trigger: "blur", message: "请输入报警时长" },
            { required: true, message: "请输入报警时长", validator: this.spaceJudgment, trigger: "blur" }
          ],
          dealTime: [
            { required: true, trigger: "blur", message: "请输入处理时长" },
            { required: true, message: "请输入处理时长", validator: this.spaceJudgment, trigger: "blur" }
          ],
        },
        //报警设置
        setUpType:false,
        setUpForm:{},
        // 继电器
        relayList: [],
        relayNumList:[
          {name:1},
          {name:2},
          {name:3},
          {name:4},
          {name:5},
          {name:6},
          {name:7},
          {name:8},
          {name:9},
          {name:10},
          {name:11},
          {name:12}
        ],
        hardwardTypeList:[
          {value:1,label:"老继电器"},
          {value:2,label:"新继电器"}
        ]
      };
    },
    created() {

    },
    mounted(){
      this.subscriptionMQTT();
      this.filterDept();
      this.listDepartments();
      this.getList();
      this.getRelayList();
    },
    methods: {
      selectFocus(){
        if(!this.selectList[0]){
          this.filterDept();
        }
      },
      // 查询继电器列表
      getRelayList(){
        listRelay({"type": 1}).then(response => {
          this.relayList = response.data;
          if(this.form.relayCode){
            let self = this
            let num = ""
            for(let i=0;i<self.relayList.length;i++){
              if(self.relayList[i].code == this.form.relayCode){
                num = self.relayList[i].routeNum
              }
            }
            let list = [];
            for(let i=0;i<num;i++){
              let obj = {
                name:i+1
              }
              list.push(obj);
            }
            this.relayNumList = list;
          }
        });
      },
      //报警器开启关闭方法
      changeIsNeedCaptcha(row){
        let self = this;
        console.log("row.deviceStatus",row.deviceStatus);
        let text = row.deviceStatus==1?'停用':(row.deviceStatus==0?'启用':'')
        this.$confirm(`是否`+text+`此设备`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(async () => {
          self.switchChange(row)
        }).catch(() => {

        })
      },
      //开关按钮
      switchChange(row){
        //编辑
        let obj = {
          id:row.id,
          deviceStatus:row.deviceStatus == 1?0:1
        }
        this.form.type = "AI_ALARM";
        updateHardware(obj).then(response => {
          if (response.code == 200){
            row.deviceStatus = row.deviceStatus == 1?0:1;
          }
        });
      },
      //获取学院列表
      listDepartments(){
        listDepartments().then(response => {
          this.optionsListOne = response.data;
        });
      },
      pageToggle(type,item){
        let self = this;
        if(type == 1){
          //新增
          this.dialogTitle = '新增';
          this.$set(this,'form',{
            hardwareNum:"",
            subjectId:"",
            hardwareType:1,
            relayCode:"",
            bit:"",
            configName:"",
            configStatus:"",
          });
          this.clearClick();
          this.addDialogType = true;
        }else if(type == 2){
          // 编辑
          this.dialogTitle = '编辑';
          let obj = {
            id:item.id,
            subjectId:item.subjectId,
            hardwareNum:item.hardwareNum,
            hardwareType:item.hardwareType,
            relayCode:item.relayCode,
            bit:item.bit,
            configName:item.configName,
            configStatus:item.configStatus,
          };
          this.$set(this,'form',obj);
          this.clearClick();
          this.addDialogType = true;
        }else if(type == 3){
          // 删除
          this.$confirm('确认要删除吗?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            delHardware(item.id).then(response => {
              if (response.code == 200){
                self.msgSuccess(response.msg);
                self.getList();
              }
            });
          }).then(() => {
          }).catch(() => {});
        }else if(type == 4){
          //报警设置
          if(self.ids.length>0) {
            this.setUpForm = {
              ringTime:"",
              dealTime:""
            }
            this.setUpType = true;
          }else{
            this.msgError('请选择要设置的报警器')
          }
        }
      },
      //查询当前院系
      filterDept(){
        filterDept().then(response => {
          let idText = "";
          for(let i=0;i<response.data.length;i++){
            if(i==0){
              idText = idText + response.data[i].deptId;
            }else{
              idText = idText +','+ response.data[i].deptId;
            }
          }
          //查询院系下实验室
          getSubList(idText).then(response => {
            //当前列表
            this.selectList = JSON.parse(JSON.stringify(response.data));
            //原始列表数据
            this.selectListData = JSON.parse(JSON.stringify(response.data));
          });
        });
      },
      /** 实验室-本地懒加载 */
      getSelectList(val) {
        let self = this;
        let list = [];
        for(let i=0;i<self.selectListData.length;i++){
          if(self.selectListData[i].name.indexOf(val) != -1){
            list.push(self.selectListData[i]);
          }
        }
        this.selectList = JSON.parse(JSON.stringify(list))
      },
      //实验室选中清除
      clearClick(){
        this.selectList = JSON.parse(JSON.stringify(this.selectListData))
      },
      submitForm(){
        this.$refs["form"].validate((valid) => {
          if (valid) {
            if(this.form.id){
              //编辑
              this.form.type = "AI_ALARM";
              updateHardware(this.form).then(response => {
                if (response.code == 200){
                  this.addDialogType = false;
                  this.msgSuccess(response.msg);
                  this.getList();
                }
              });
            }else{
              //新增
              this.form.type = "AI_ALARM";
              addHardware(this.form).then(response => {
                if (response.code == 200){
                  this.addDialogType = false;
                  this.msgSuccess(response.msg);
                  this.resetQuery();
                }
              });
            }
          }
        })
      },
      cancel(){
        this.addDialogType = false;
      },
      //获取数据列表
      getList(){
        this.queryParamsData = JSON.parse(JSON.stringify(this.queryParams));
        this.queryParamsData.type = 'AI_ALARM';
        listHardware(this.queryParamsData).then(response => {
          this.total = response.total;
          this.tableList = response.rows;
        });
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParamsData.pageNum = 1;
        this.queryParamsData.pageSize = 10;
        this.queryParams = JSON.parse(JSON.stringify(this.queryParamsData));
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.$set(this,'queryParamsData',{});
        this.$set(this,'queryParams',{});
        this.handleQuery();
      },
      //导入页面关闭
      importOpenOff(){
        this.importOpen = false;
        this.getImportData.downFile = false;
        this.getImportData.successNum = 0;
        this.getImportData.failureNum = 0;
        this.getImportData.textName = "";
      },
      /** 导入按钮操作 */
      importButton(item){
        if(item.command == 1){
          //  下载模板
          this.download('/laboratory/hardware/importTemplate', {}, `导入模板.xlsx`)
        }else if(item.command == 2){
          //  导入数据
          console.log('导入数据');
          this.importOpen = true;
        }
      },
      /** 下载模板操作 */
      importTemplate() {
        this.download('/laboratory/hardware/importTemplate', {}, `导入模板.xlsx`)
      },
      /*下载失败列表*/
      failureExcel(){
        this.download('/laboratory/hardware/importErrorData', {}, `失败报表.xlsx`)
      },
      //****************************************导入功能**************************************
      handleAvatarSuccess(res, file) {
        if(res.code == 200){
          if(res.data.downFile){
            this.getImportData.downFile = res.data.downFile
            this.getImportData.successNum = res.data.successNum
            this.getImportData.failureNum = res.data.failureNum
          }else{
            this.msgSuccess(res.msg);
            this.importOpen = false;
            this.resetQuery();
          }
          // this.getImportData.downFile = res.data.downFile
          // this.getImportData.successNum = res.data.successNum
          // this.getImportData.failureNum = res.data.failureNum
          // this.importOpen = false;
          // this.getList();
        }else{
          this.msgError(res.msg);
        }
        this.loading = false;
      },
      beforeAvatarUpload(file) {
        let type = false;
        console.log('file',file);
        if (file.type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' || file.type == 'application/vnd.ms-excel') {
          this.getImportData.textName = file.name;
          type = true;
          this.loading = true;
        }else{
          this.msgError('只能上传xls/xlsx格式文件')
          type = false;
        }
        return type;
      },
      //修改报警设置
      setUpSubmitForm(){
        this.$refs["setUpForm"].validate((valid) => {
          if (valid) {
            let obj = {
              ids:this.ids,
              ringTime:parseInt(this.setUpForm.ringTime),
              dealTime:parseInt(this.setUpForm.dealTime),
            }
            alarmSettings(obj).then(response => {
              if(response.code == 200){
                this.setUpType = false;
                this.msgSuccess(response.msg);
                this.getList();
              }
            });
          }
        })
      },
      //关闭报警设置页面
      setUpCancel(){
        this.setUpType = false;
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.selectedNum = selection.length;
        this.ids = selection.map(item => item.id);
        this.single = selection.length != 1;
        this.multiple = !selection.length;
      },
      /*===记录勾选数据===
        需要再el-table 添加  :row-key="getRowKeys"
        需要在selection 添加 :reserve-selection="true"
      */
      getRowKeys(row) {
        return row.id
      },
      //MQTT订阅
      subscriptionMQTT(){
        let self = this;
        this.client = mqtt.connect(process.env.VUE_APP_BASE_MQTT_API, {
          username: process.env.VUE_APP_BASE_MQTT_USERNAME,
          password: process.env.VUE_APP_BASE_MQTT_PASSWORD
        });
        this.client.on("connect", e =>{
          console.log("连接成功");
          this.client.subscribe(this.mtopic, (err) => {
            if (!err) {
              console.log("订阅成功:" + this.mtopic);
            }
          });
        });
        this.client.on("message", (topic, message) => {
          if (message){
            let data = JSON.parse(message)
            if(topic == this.mtopic){
              for(let i=0;i<data.data.length;i++){
                for(let o=0;o<self.tableList.length;o++){
                  if(data.data[i].num == self.tableList[o].id){
                    if(data.data[i].hardwareOperate == 'CLOSE'){
                      //停用并上线
                      self.$set(self.tableList[o],'status',4);
                    }else if(data.data[i].hardwareOperate == 'OPEN'){
                      //启用并上线
                      self.$set(self.tableList[o],'status',3);
                    }else if(data.data[i].hardwareOperate == 'OFFLINE'){
                      //离线
                      self.$set(self.tableList[o],'status',0);
                    }
                  }
                }
              }
            }
          }
        });
      },
      //取消订阅关闭MQTT连接
      offMQTT(){
        this.client.unsubscribe(this.mtopic, error => {
          if (error) {
            console.log('Unsubscribe error', error)
          }
        })
        this.client.end();
        this.client = {};
      },
    },
    beforeDestroy() {
      //清除定时器
      let self = this;
      self.offMQTT();
      console.log("beforeDestroy");
    },
  }
</script>

<style scoped lang="scss">
  .smartAlarm{
    flex:1;
    display: flex;
    flex-direction: column;
    overflow: hidden!important;
    padding:20px !important;
    p{
      margin:0;
      padding:0;
    }
    .form-box{
      .form-dropdown-box{
        display: flex;
        margin:0;
        padding:0 10px;
        cursor: pointer;
        height:40px;
        img:nth-child(1){
          width:16px;
          height:16px;
          margin-top:12px;
        }
        p{
          width:47px;
          text-align: center;
          font-size:14px;
          margin:0;
          line-height:40px;
        }
        img:nth-child(3){
          width:10px;
          height:6px;
          margin-top:17px;
        }
      }
    }
    .button-box{
      display: flex;
    }
  }
</style>
<style lang="scss">
  .import-dialog-box{
    .import-dialog-upLoad-box{
      .el-upload{
        width:450px;
        margin:0 55px;
        .el-upload-dragger{
          width:450px;
          .el-icon-upload{
            font-size:100px;
            color:#CBE6FE;
          }
          .el-upload__text{
            margin-top:20px;
          }
        }
      }
      .el-upload__tip{
        margin-left:60px;
        font-size:14px;
        margin-top:10px;
      }
      .el-upload-text-box{
        background: #F5F5F5;
        border-radius: 10px;
        margin:15px 30px 0;
        padding:0 20px 15px;
        overflow: hidden;
        *{
          margin:0;
        }
        .img-text-box{
          display: flex;
          margin-top:15px;
          img{
            width:16px;
            height:16px;
            margin-right:13px;
          }
          p{
            height:16px;
            line-height:16px;
            font-size:12px;
          }
        }
        .text-p{
          margin-top:15px;
          margin-left:29px;
          height:16px;
          line-height:16px;
          font-size:12px;
        }
      }
    }
    .teacher-import-dialog-button-box{
      display: flex;
      width:190px;
      margin:0 auto;
      p{
        width:70px;
        height:30px;
        line-height:30px;
        font-size:14px;
        margin:0 auto;
      }
    }
    .teacher-import-dialog-position-box{
      width:100%;
      height:100%;
      position: absolute;
      top:0;
      left:0;
      z-index: 999;
      background: rgba(255,255,255,0.4);
      border-radius:20px;
    }
  }
</style>

<style lang="scss">
  .smartAlarm{
    .switch .el-switch__label {
      position: absolute;
      display: none;
      color: #fff !important;
    }
    .switch .el-switch__label--right {
      z-index: 1;
    }
    .switch .el-switch__label--right span{
      margin-right:10px;
    }
    .switch .el-switch__label--left {
      z-index: 1;
    }
    .switch .el-switch__label--left span{
      margin-left: 14px;
    }
    .switch .el-switch__label.is-active {
      display: block;
    }
    .switch.el-switch .el-switch__core,
    .el-switch .el-switch__label {
      width: 64px !important;
      margin: 0;
    }
  }
</style>
